// really really quick and dirty code to just GET THESE BMP's OUT!
// I don't plan on distributing this :P

// oops, I guess I did... oh well :)

/* Version history:
    0.1	-- first official release
	0.11 -- Option to Filter out Mipmaps
			Extract RAWs a bit better

   Future plans:
    Start over from scratch :) -- to interface with TPLACE design
	Name the bitmaps (from the info in the GRF)
	Extract Bumpmapped textures correctly
	Import/modify bitmaps
*/

#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<string.h>
#include<ctype.h>

void main()
{
	char pid[256], swp[256], out[256];
	FILE *pidfile, *swpfile, *outfile;

	printf("SWPExtract v0.11 official.");
	printf("\n quick and dirty SWP hacker by PenguiN");
	printf("\n this code sucks. this util is horrible. if you don't like it, don't use it :P");

        printf("\n\n This is an UNSUPPORTED ALPHA.  Use at your own risk!!");
        printf("\n Neither THS nor the authors of this program are responsible for");
        printf("\n any problems that may occur from the use of this program.  It");
        printf("\n didn't break our computers, but you never know with C/C++");

	printf("\n\nPlease make sure that the PID and SWP are for the same level\n");
	printf("(note: you may not have the level's SWP if you haven't played it recently)\n");
	printf("Enter PID file: ");
	scanf("%s", pid);
	printf("\nEnter SWP file: ");
	scanf("%s", swp);
	printf("\nEnter existing output directory (with all the \\\'s): ");
	scanf("%s", out);


	pidfile = fopen(pid, "rb");
	swpfile = fopen(swp, "rb");

	if (pidfile == NULL || swpfile == NULL)
	{
		printf("\n ERROR! :P .. can't open file \n");
		exit(1);
	}

	
	unsigned long ptag;

	fseek(pidfile, 0, SEEK_SET);
	fread(&ptag, sizeof(unsigned long), 1, pidfile);

	if (ptag != 304)
	{
		printf("\nERROR! not a pid :P\n");
		exit(2);
	}


	//step 1: load the palette blocks
	unsigned long numPalBlocks;
	char **PalBlock;
	unsigned long *PalSize;

	fseek(pidfile, 0x014, SEEK_SET);
	fread(&numPalBlocks, sizeof(unsigned long), 1, pidfile);

	PalBlock = new char * [numPalBlocks+1];
	PalSize = new unsigned long [numPalBlocks+1];

	fseek(pidfile, 0x020, SEEK_SET);
	for(int i=0; i < numPalBlocks; i++)
	{
		unsigned long offToNext, numEntries;
		fread(&offToNext, sizeof(unsigned long), 1, pidfile);
		fread(&numEntries, sizeof(unsigned long), 1, pidfile);
		PalBlock[i] = new char [(int)numEntries * 4];
		PalSize[i] = numEntries;
		fseek(pidfile, 4, SEEK_CUR);
		fread(PalBlock[i], sizeof(char), numEntries * 4, pidfile);
		fseek(pidfile, 4, SEEK_CUR);
	}
	
	PalSize[i]=256;			// extra palette for non-paletted entries
	PalBlock[i] = new char [256 * 4];
	for (int j=0; j<256*4; j+=4)
	{
		PalBlock[i][j]=j/4;
		PalBlock[i][j+1]=j/4;
		PalBlock[i][j+2]=j/4;
		PalBlock[i][j+3]=0;
	}

	//step 2: get some inf0, prepare for loop
	unsigned long numPics, offToIndex;

	fseek(pidfile, 0x08, SEEK_SET);
	fread(&offToIndex, sizeof(unsigned long), 1, pidfile);
	fread(&numPics, sizeof(unsigned long), 1, pidfile);

	printf("\nFile contains %lu textures. Valid numbers are between 0 and %lu", numPics, numPics - 1);

	unsigned long startNum=0, endNum=0;

	do
	{
		printf("\nEnter block number at which to start extraction:");
		scanf("%u", &startNum);
	} while(startNum < 0 || startNum > numPics-1);
	
	do
	{
		printf("\nEnter block number at which to end extraction:");
		scanf("%u", &endNum);
	} while(endNum < startNum || endNum > numPics-1);

	char CExtRaw;
	int ExtRaw;
	
	do
	{
		printf("\nExtract Unrecognized Data as .RAW? (Y/N):");
		CExtRaw = toupper(_getche());
	} while(CExtRaw != 'Y' && CExtRaw != 'N');

	if (CExtRaw == 'Y')
		ExtRaw = 1;
	else
		ExtRaw = 0;

	char CExtMIPs;
	int ExtMIPs;

	do
	{
		printf("\nExtract all mipmaps of textures too? (Y/N):");
		CExtMIPs = toupper(_getche());
	} while(CExtMIPs != 'Y' && CExtMIPs != 'N');

	if (CExtMIPs == 'Y')
		ExtMIPs = 1;
	else
		ExtMIPs = 0;

	printf("\n\n hit enter to begin, ctrl-break to kill");
	_getch();

	fseek(pidfile, offToIndex, SEEK_SET);
	for(i=0; i < startNum; i++)
	{
		unsigned long entlen;
		fread(&entlen, sizeof(unsigned long), 1, pidfile);
		fseek(pidfile, entlen - sizeof(unsigned long), SEEK_CUR);
	}

	for(i = startNum; i <= endNum; i++)
	{
		// step 3: get the data from the PID
		unsigned long entlen, swpoffset, texwidth, height, width,
			bitdepth, palindex, isMIP;

		fread(&entlen, sizeof(unsigned long), 1, pidfile);
		fread(&swpoffset, sizeof(unsigned long), 1, pidfile);
		fread(&texwidth, sizeof(unsigned long), 1, pidfile);
		fread(&height, sizeof(unsigned long), 1, pidfile);
		fread(&width, sizeof(unsigned long), 1, pidfile);
		fread(&bitdepth, sizeof(unsigned long), 1, pidfile);
		fseek(pidfile, 16, SEEK_CUR);
		fread(&palindex, sizeof(unsigned long), 1, pidfile);
		fseek(pidfile, 8, SEEK_CUR);
		fread(&isMIP, sizeof(unsigned long), 1, pidfile);
		if (palindex == 0xFFFFFFFF)
			palindex = numPalBlocks;

		fseek(pidfile, entlen - 56, SEEK_CUR);
		
		// skip mips
		if(isMIP && !ExtMIPs)
			continue;

		// skip bumpmaps
		if (bitdepth==16 && !ExtRaw)
                        continue;

		// step 4: assemble the BMP
		char tempName[16];
		char fileName[256];
		sprintf(tempName, "%05d", i);

		strcpy(fileName, out);
		strcat(fileName, tempName);
			
        if (bitdepth==8)
			strcat(fileName, ".bmp");
        else
			strcat(fileName, ".raw");

		printf("\n%s", fileName);

		outfile = fopen(fileName, "wb");

		if (!outfile)
		{
			printf("\nFailure opening file!");
			exit(3);
		}


		// step 4a: header
		unsigned long BMDataSize = height * texwidth;
		unsigned long tempLong;
		unsigned short int tempShort;
			
		if (bitdepth==8)
		{
			fwrite("BM", sizeof(char), 2, outfile);
			tempLong = 0x0436 + BMDataSize;
			fwrite(&tempLong, sizeof(long), 1, outfile);
			tempLong = 0;
			fwrite(&tempLong, sizeof(long), 1, outfile);
			tempLong = 0x0436;
			fwrite(&tempLong, sizeof(long), 1, outfile);
			tempLong = 0x028;
			fwrite(&tempLong, sizeof(long), 1, outfile);
			tempLong = texwidth;
			fwrite(&tempLong, sizeof(long), 1, outfile);
			fwrite(&height, sizeof(long), 1, outfile);
			tempShort = 1;
			fwrite(&tempShort, sizeof(short int), 1, outfile);
			tempShort = 8;
			fwrite(&tempShort, sizeof(short int), 1, outfile);
			tempLong = 0;
			fwrite(&tempLong, sizeof(long), 1, outfile);
			fwrite(&BMDataSize, sizeof(long), 1, outfile);
			tempLong = 0x0B12;
			fwrite(&tempLong, sizeof(long), 1, outfile);
			fwrite(&tempLong, sizeof(long), 1, outfile);
			tempLong = 0x0100;
			fwrite(&tempLong, sizeof(long), 1, outfile);
			tempLong = PalSize[palindex];
			fwrite(&tempLong, sizeof(long), 1, outfile);
		
			// step 4b: palette
			char tempChar[4];
			for(j = 0; j < PalSize[palindex]; j++)
			{
				for(int k = 0; k < 4; k++)
					tempChar[k] = PalBlock[palindex][j*4 + k];
				fwrite(tempChar, sizeof(char), 4, outfile);
			}
			for(;j < 256; j++)
			{
				for(int k = 0; k < 4; k++)
					tempChar[k] = 0;
				fwrite(tempChar, sizeof(char), 4, outfile);
			}
		}		

		// Write palette to separate file
		
		if (bitdepth == 16)
		{
			// step 4b: palette
			char tempChar[4];
			FILE *palfile;

			char tempName[16];
			char fileName[256];
			sprintf(tempName, "%05d", i);

			strcpy(fileName, out);
			strcat(fileName, tempName);
			
			strcat(fileName, ".pal");

			printf("\n%s", fileName);
	
			palfile = fopen(fileName, "wb");

			if (!outfile)
			{
				printf("\nFailure opening file!");
				exit(3);
			}
			
			for(j = 0; j < PalSize[palindex]; j++)
			{
				for(int k = 0; k < 4; k++)
					tempChar[k] = PalBlock[palindex][j*4 + k];
				fwrite(tempChar, sizeof(char), 4, palfile);
			}
			for(;j < 256; j++)
			{
				for(int k = 0; k < 4; k++)
					tempChar[k] = 0;
				fwrite(tempChar, sizeof(char), 4, palfile);
			}
			
			fclose(palfile);
		}


		// step 4c: copy data from SWP .. one row at a time

		unsigned char *buffer;
		unsigned long bufferlen;

		fseek(swpfile, swpoffset, SEEK_SET);

		bufferlen = texwidth*(bitdepth/8);
		buffer = new unsigned char [bufferlen];
		
		for(j = 0; j < height; j++)
		{
				
			fread( buffer, sizeof(char), bufferlen, swpfile );
			fwrite( buffer, sizeof(char), bufferlen, outfile );
			fseek( swpfile, width - bufferlen, SEEK_CUR );
		}

		delete [] buffer;

		fclose(outfile);
	}
	
	fclose(pidfile);
	fclose(swpfile);
	printf("\n");
}
